React

react-apexstock is a thin, typed React component around the imperative ApexStock class. It creates the instance on mount, forwards prop changes to update(), and tears it down on unmount.

Installation

npm install react-apexstock apexstock apexcharts

apexcharts, apexstock, react, and react-dom are peer dependencies. The wrapper requires apexstock >=0.5.0 <1 and apexcharts ^7.1.0 || ^8.0.0, and those two have to agree: apexstock 0.5.x is the line that pairs with ApexCharts 7.1 and later, so an older apexstock alongside apexcharts@7 will not resolve. ApexCharts 8 needs apexstock 0.5.2 and react-apexstock 0.2.3 or newer: apexstock 0.5.0 and 0.5.1 and react-apexstock 0.2.2 accept ^7.1.0 only.

ApexCharts can reach the library three ways. Pass it to the component with the apexCharts prop, register it once app-wide with ApexStock.setApexCharts(ApexCharts), or leave it on window.ApexCharts as the core library expects. Under a bundler, prefer one of the first two.

Usage

import { useMemo } from 'react'
import ApexStock from 'react-apexstock'

export function PriceChart({ data }) {
  // Memoize so the chart only updates when inputs actually change.
  const options = useMemo(
    () => ({
      chart: { height: 420 },
      theme: { mode: 'light' },
    }),
    []
  )
  const series = useMemo(() => [{ name: 'Price', data }], [data])

  return <ApexStock options={options} series={series} style={{ width: '100%' }} />
}

OHLC points use the ApexStock shape { x, y: [open, high, low, close], v }, see Data Format.

Props

PropTypeDescription
optionsStockChartOptionsFull chart options (the 2nd argument to new ApexStock). Required.
seriesStockChartOptions["series"]Convenience: overrides options.series, handy for frequently-changing data.
classNamestringClass applied to the container element.
styleReact.CSSPropertiesInline styles applied to the container element.

Pass stable / memoized options and series. A new object identity on every render triggers an update(). Keep static config in options and pass changing data through series.

Accessing the instance

The component forwards a ref exposing an imperative handle. getInstance() returns the live ApexStock instance (call any of its methods) or null before mount; getElement() returns the container <div>.

import { useRef } from 'react'
import ApexStock, { type ApexStockRef } from 'react-apexstock'

function Toolbar({ series }) {
  const ref = useRef<ApexStockRef>(null)
  const addRSI = () => ref.current?.getInstance()?.updateIndicator('rsi')

  return (
    <>
      <button onClick={addRSI}>Add RSI</button>
      <ApexStock ref={ref} options={{ chart: { height: 400 }, series }} />
    </>
  )
}

Through the instance you can reach the full core API: indicators, trading overlays, streaming, theme switching, and export.

Server-side rendering

The component renders only a container <div> on the server; the chart is created in a client-only effect. The core apexstock package is import-safe in Node, but rendering needs a DOM. No extra guards are required in Next.js or other SSR setups.

Licensing

Register your license key once, before charts render, with the core class. See Installation & Usage.

Angular

ngx-apexstock is a thin, typed standalone Angular component around the imperative ApexStock class. It creates the instance after the view initializes, forwards input changes to update(), and tears it down on destroy.

Installation

npm install ngx-apexstock apexstock apexcharts

apexcharts, apexstock, @angular/core, and @angular/common (16 or newer) are peer dependencies. The wrapper requires apexstock >=0.5.0 <1 and apexcharts ^7.1.0 || ^8.0.0, and those two have to agree: apexstock 0.5.x is the line that pairs with ApexCharts 7.1 and later, so an older apexstock alongside apexcharts@7 will not resolve. ApexCharts 8 needs apexstock 0.5.2 and ngx-apexstock 0.2.3 or newer: apexstock 0.5.0 and 0.5.1 and ngx-apexstock 0.2.2 accept ^7.1.0 only.

ApexCharts can reach the library three ways. Pass it to the component with the apexCharts input, register it once app-wide with ApexStock.setApexCharts(ApexCharts), or leave it on window.ApexCharts as the core library expects. Under a bundler, prefer one of the first two.

Usage

ApexStockComponent is standalone, so import it directly into a component's imports, no module required. Its selector is apex-stock.

import { Component } from '@angular/core'
import { ApexStockComponent } from 'ngx-apexstock'

@Component({
  selector: 'app-price',
  standalone: true,
  imports: [ApexStockComponent],
  template: `<apex-stock [options]="options" [series]="series"></apex-stock>`,
})
export class PriceComponent {
  options = { chart: { height: 420 }, theme: { mode: 'light' as const } }
  series = [{ name: 'Price', data: [] as { x: number; y: number[] }[] }]
}

Using NgModules? Add ApexStockComponent to the module's imports, standalone components are importable into modules. OHLC points use the ApexStock shape { x, y: [open, high, low, close], v }, see Data Format.

Inputs

InputTypeDescription
optionsStockChartOptionsFull chart options (the 2nd argument to new ApexStock). Required.
seriesStockChartOptions["series"]Convenience: overrides options.series.

Updates fire when an input changes via Angular change detection. Assign a new object/array reference (rather than mutating in place) to trigger an update.

Accessing the instance

Grab the component with @ViewChild. getInstance() returns the live ApexStock instance (call any method) or null before view init; getElement() returns the container <div>.

import { Component, ViewChild } from '@angular/core'
import { ApexStockComponent } from 'ngx-apexstock'

@Component({
  standalone: true,
  imports: [ApexStockComponent],
  template: `
    <button (click)="addRSI()">Add RSI</button>
    <apex-stock #chart [options]="options"></apex-stock>
  `,
})
export class ChartComponent {
  @ViewChild('chart') chart!: ApexStockComponent
  options = { chart: { height: 400 } }

  addRSI() {
    this.chart.getInstance()?.updateIndicator('rsi')
  }
}

Through the instance you can reach the full core API: indicators, trading overlays, streaming, theme switching, and export.

Server-side rendering

The component renders only a container <div> on the server; the chart is created in a client-only ngAfterViewInit. The core apexstock package is import-safe in Node, but rendering needs a DOM.

Licensing

Register your license key once, before charts render, with the core class. See Installation & Usage.

Vue

vue-apexstock is a thin, typed Vue 3 component around the imperative ApexStock class. It creates the instance on mount, forwards prop changes to update(), and tears it down on unmount.

Installation

npm install vue-apexstock apexstock apexcharts

apexcharts, apexstock, and vue (3.3 or newer) are peer dependencies. The wrapper requires apexstock >=0.5.0 <1 and apexcharts ^7.1.0 || ^8.0.0, and those two have to agree: apexstock 0.5.x is the line that pairs with ApexCharts 7.1 and later, so an older apexstock alongside apexcharts@7 will not resolve. ApexCharts 8 needs apexstock 0.5.2 and vue-apexstock 0.2.3 or newer: apexstock 0.5.0 and 0.5.1 and vue-apexstock 0.2.2 accept ^7.1.0 only.

ApexCharts can reach the library three ways. Pass it to the component with the apexCharts prop, register it once app-wide with ApexStock.setApexCharts(ApexCharts), or leave it on window.ApexCharts as the core library expects. Under a bundler, prefer one of the first two.

Usage

<script setup>
import { ref } from 'vue'
import ApexStock from 'vue-apexstock'

const options = { chart: { height: 420 }, theme: { mode: 'light' } }
// A new array identity on data change triggers an update.
const series = ref([{ name: 'Price', data: [] }])
</script>

<template>
  <ApexStock :options="options" :series="series" style="width: 100%" />
</template>

OHLC points use the ApexStock shape { x, y: [open, high, low, close], v }, see Data Format.

Props

PropTypeDescription
optionsStockChartOptionsFull chart options (the 2nd argument to new ApexStock). Required.
seriesStockChartOptions["series"]Convenience: overrides options.series.

Updates fire when the options or series identity changes (assign a new object/array). In-place mutation of the same object is intentionally not deep-watched, to avoid the cost of deep-watching large datasets.

Accessing the instance

Put a ref on the component. getInstance() returns the live ApexStock instance (call any method) or null before mount; getElement() returns the container <div>.

<script setup>
import { ref } from 'vue'
import ApexStock from 'vue-apexstock'

const chart = ref()
const addRSI = () => chart.value?.getInstance()?.updateIndicator('rsi')
</script>

<template>
  <button @click="addRSI">Add RSI</button>
  <ApexStock ref="chart" :options="{ chart: { height: 400 }, series }" />
</template>

Through the instance you can reach the full core API: indicators, trading overlays, streaming, theme switching, and export.

Server-side rendering

The component renders only a container <div> on the server; the chart is created in a client-only onMounted hook. The core apexstock package is import-safe in Node, but rendering needs a DOM.

Licensing

Register your license key once, before charts render, with the core class. See Installation & Usage.